Attribute VB_Name = "callbacks"
'******************************************************************
'*  VB file:   callback.bas                                       *
'*              En este modulo nos encontramos con las funciones  *
'*              que son llamadas por las callbacks del programa   *
'*                                                                *
'*              MyFrameCallback se ejecuta cuando se ha capturado *
'*              un frame.                                         *
'*                                                                *
'*              MyStatusCallback se ejecuta cuando ocurren algunos*
'*              estados de la captura.                            *
'*              Mediante esta funcin solucionamos el problema de *
'*              la multitarea
'******************************************************************

Option Explicit
Private Info_imagen As VIDEOHDR

Public mapa As BITMAPINFO
Public imagen As BITMAP
Public dwsize As Long

'BANDERAS DEL RATON

Const MOUSEEVENTF_ABSOLUTE = &H8000     'Indica que el dx y el dy con_
                                        'tienen coordenadas absolutas nor_
                                        'malizadas
Const MOUSEEVENTF_LEFTDOWN = &H2        'Indica que el boton de la izda
                                        'est pulsado
Const MOUSEEVENTF_LEFTUP = &H4          'Indica que el boton de la izda
                                        'no est pulsado
Const MOUSEEVENTF_MIDDLEDOWN = &H20     'Indica que el boton del medio est
                                        'pulsado
Const MOUSEEVENTF_MIDDLEUP = &H40       'Indica que el boton del medio no
                                        'est pulsado
Const MOUSEEVENTF_MOVE = &H1            'Indica que ha ocurrido movimiento
Const MOUSEEVENTF_RIGHTDOWN = &H8       'Indica que el botn de la dcha est
                                        'pulsado
Const MOUSEEVENTF_RIGHTUP = &H10        'Indica que el botn de la dcha no
                                        'est pulsado
Const MOUSEEVENTF_WHEEL = &H80          'Indica que la rueda ha sido movida
Const MOUSEEVENTF_XDOWN = &H100         'Windows 2000: X botn ha sido pulsado
Const MOUSEEVENTF_XUP = &H200           'Windows 2000: Y botn ha dejado de
                                        'ser pulsado
Const WHEEL_DELTA = 120
Const XBUTTON1 = &H1
Const XBUTTON2 = &H2



    'declaracion de la funcin para mover datos de memoria
Declare Sub RtlMoveMemory Lib "kernel32" (ByVal hpvDest _
    As Long, ByVal hpvSource As Long, ByVal cbCopy As Long)
   
    'funcin que es llamada cada vez que un frame es capturado
Function MyFrameCallback(ByVal lwnd As Long, ByVal lpVHdr As Long) As Long

Dim videoData() As Byte    'vector que se le pasa la informacin de lpVHdr
Dim buffer As Byte         'direccin del buffer descomprimido
Dim dx As Integer
Dim dy As Integer
Dim status As Byte

    'Calculamos el tamao el formato
dwsize = capGetVideoFormatSize(FrmMenu.hwndc)
capGetVideoFormat FrmMenu.hwndc, mapa, dwsize

'rellena VIDEOHDR con los datos de lpVHdr
RtlMoveMemory VarPtr(Info_imagen), lpVHdr, Len(Info_imagen)
    
'redimensionamos videoData con el tamao de de bytes usados
ReDim videoData(Info_imagen.dwBytesUsed)

'pasamos la direccin del buffer a videoData
RtlMoveMemory VarPtr(videoData(0)), Info_imagen.lpData, _
        Info_imagen.dwBytesUsed
   
'rellenamos bitmap con los valores bitmapinfoheader
imagen.bmType = 0
imagen.bmWidth = mapa.bmiHeader.biWidth
imagen.bmHeight = mapa.bmiHeader.biHeight
imagen.bmPlanes = mapa.bmiHeader.biPlanes
imagen.bmBitsPixel = mapa.bmiHeader.biBitCount
imagen.bmBits = Info_imagen.lpData
 
'Llamamos a el anlisis de la imagen
Call analisis.SetImagen

'Llamamos al procedimiento que nos da el desplazamiento
'y el estado del ratn
Call analisis.gethand(dx, dy, status)

'Dependiendo del estado anterior y del estado actual del
'ratn, realizamos los eventos del ratn
  If FrmMenu.ant_status = 1 Then
    Select Case status
        Case 0 'No detecta mano
          Call FrmMenu.mueveraton(0, 0, MOUSEEVENTF_MOVE Or MOUSEEVENTF_LEFTUP)
        Case 1 'Botn izquierdo pulsado
          Call FrmMenu.mueveraton(dx, dy, MOUSEEVENTF_MOVE Or MOUSEEVENTF_LEFTDOWN)
          FrmMenu.MousePointer = 5
          FrmMenu.StatusBar1.Panels(1).Text = "Botn izquierdo pulsado"
        Case 2 'Movimiento
          Call FrmMenu.mueveraton(0, 0, MOUSEEVENTF_MOVE Or MOUSEEVENTF_LEFTUP)
          FrmMenu.MousePointer = 0
          FrmMenu.StatusBar1.Panels(1).Text = "Ratn en movimiento"
        Case 3 'Botn derecho pulsado
          Call FrmMenu.mueveraton(0, 0, MOUSEEVENTF_MOVE Or MOUSEEVENTF_RIGHTDOWN Or MOUSEEVENTF_LEFTUP)
          FrmMenu.MousePointer = 2
          FrmMenu.StatusBar1.Panels(1).Text = "Botn derecho pulsado"
     End Select
  End If
  If FrmMenu.ant_status = 2 Then
     Select Case status
        Case 0
          Call FrmMenu.mueveraton(0, 0, MOUSEEVENTF_MOVE)
        Case 1
          Call FrmMenu.mueveraton(0, 0, MOUSEEVENTF_MOVE Or MOUSEEVENTF_LEFTDOWN)
          FrmMenu.MousePointer = 5
          FrmMenu.StatusBar1.Panels(1).Text = "Botn izquierdo pulsado"
        Case 2
          Call FrmMenu.mueveraton(dx, dy, MOUSEEVENTF_MOVE)
          FrmMenu.MousePointer = 0
          FrmMenu.StatusBar1.Panels(1).Text = "Ratn en movimiento"
        Case 3
          Call FrmMenu.mueveraton(0, 0, MOUSEEVENTF_MOVE Or MOUSEEVENTF_RIGHTDOWN)
          FrmMenu.MousePointer = 2
          FrmMenu.StatusBar1.Panels(1).Text = "Botn derecho pulsado"
        
     End Select
  End If
  If FrmMenu.ant_status = 3 Then
      Select Case status
        Case 0
          Call FrmMenu.mueveraton(0, 0, MOUSEEVENTF_MOVE Or MOUSEEVENTF_RIGHTUP)
        Case 1
          Call FrmMenu.mueveraton(0, 0, MOUSEEVENTF_MOVE Or MOUSEEVENTF_LEFTDOWN Or MOUSEEVENTF_RIGHTUP)
          FrmMenu.MousePointer = 5
          FrmMenu.StatusBar1.Panels(1).Text = "Botn izquierdo pulsado"
        Case 2
          Call FrmMenu.mueveraton(0, 0, MOUSEEVENTF_MOVE Or MOUSEEVENTF_RIGHTUP)
          FrmMenu.MousePointer = 0
          FrmMenu.StatusBar1.Panels(1).Text = "Ratn en movimiento"
        Case 3
          Call FrmMenu.mueveraton(dx, dy, MOUSEEVENTF_MOVE Or MOUSEEVENTF_RIGHTDOWN)
          FrmMenu.MousePointer = 2
          FrmMenu.StatusBar1.Panels(1).Text = "Botn derecho pulsado"
      End Select
  End If
  If status = 0 Then
   FrmMenu.ant_status = FrmMenu.ant_status
  Else
   FrmMenu.ant_status = status
  End If
End Function

Function MyStatusCallback(ByVal lwnd As Long, ByVal iID As Long, ByVal ipstrStatusText As Long) As Long

 If iID <> 301 Then
   
   Exit Function
 Else    ' iID=301 nos indica el estado de captura parada
         ' si reactivar es true indica que la captura no
         ' se ha producido con el botn de parar captura
 If FrmMenu.reactivar = True Then
 'llamamos al timer que nos reactiva la captura
 FrmMenu.timercaptura.Enabled = True
 End If
  
 End If

End Function
